#include <signal.h>
#include <values.h>
#include <dos.h>
#include "relspeed.h"

static void interrupt reset_count (...);
static unsigned long speed, rel_speed;

#ifdef __TURBOC__
/**************************************************************************

 *************************************************************************/
unsigned long get_relspeed (void)
{
   void interrupt (*prev)(...);
   void (*prev_ctrlc)(int sig);

   prev_ctrlc = signal(SIGINT, (void (*)(int))SIG_IGN);
   prev = getvect(0x1c);
   setvect(0x1c, reset_count);
   while(++speed < MAXLONG)
      ;

   setvect(0x1c, prev);
   signal(SIGINT, prev_ctrlc);

   return rel_speed;
}


/**************************************************************************

 *************************************************************************/
static void interrupt reset_count (...)
{
   static int called = 0;

   if (called++ == 0)
   {
      speed = 0;
   }
   else 
   {
      rel_speed = speed;
      speed = MAXLONG;
      called = 0;
   }
}
#else
/**************************************************************************

 *************************************************************************/
unsigned long get_relspeed (void)
{
   return 10000;
}
#endif

/**************************************************************************

 *************************************************************************/
#ifdef MAIN_RELSPEED
#include <stdio.h>
int main (int argc, char **argv)
{
   int i;

   for (i = 0; i < 10; i++)
      printf("rel_speed (long int)= %ld\n", get_relspeed());

   return 0;
}
#endif

